//********************************//
//	     (c) McKay		  //   Do NOT copy or redistribute
//********************************//

--LAST EDITED 03.December.2010  14:25

--Minecraft SWEP version 2.2 [offline, garrysmod.org, multiplayer]
--This gets updated weekly, whereas the toybox minecraft swep gets updated daily (if)
--If you read this, you are awesome!

local debuginfo = 0
local firstspawn = 1

if ( CLIENT ) then

	SWEP.PrintName            = "Minecraft Block"
	SWEP.Slot                = 3
	SWEP.SlotPos            = 1
	SWEP.Author            = "McKay"
	SWEP.WepSelectIcon = surface.GetTextureID("VGUI/entities/minecraft_swep")
	SWEP.BounceWeaponIcon = true
	SWEP.DrawAmmo            = false
	SWEP.DrawCrosshair        = true
end

if (SERVER) then

	AddCSLuaFile( "shared.lua" )

	SWEP.Weight                = 5
	SWEP.AutoSwitchTo        = false
	SWEP.AutoSwitchFrom        = false
end

SWEP.Category = "Minecraft"
SWEP.Contact        = "mckay@gmx.at"
SWEP.Purpose        = ""
SWEP.Instructions    = "Right-click to place a block, left click to destroy a block, press RELOAD to select block type!"
SWEP.ViewModel            = "models/mc_block.mdl"
SWEP.HoldType = "Pistol"
SWEP.AdminSpawnable = true
SWEP.Spawnable 		= true

SWEP.WorldModel            = ""

SWEP.Primary.ClipSize        = -1
SWEP.Primary.DefaultClip    = -1
SWEP.Primary.Automatic        = false
SWEP.Primary.Ammo            = "none"
SWEP.Secondary.ClipSize        = -1
SWEP.Secondary.DefaultClip    = -1
SWEP.Secondary.Automatic    = false
SWEP.Secondary.Ammo            = "none"
SWEP.base = "weapon_base"
SWEP.Precache = 1

function SWEP:Precache()
    util.PrecacheSound("minecraft/concrete_impact_hard3.wav")
    util.PrecacheSound("minecraft/concrete_impact_hard2.wav")
    util.PrecacheSound("minecraft/concrete_impact_hard1.wav")
    util.PrecacheSound("minecraft/concrete_break3.wav.wav")
    util.PrecacheSound("minecraft/concrete_break2.wav.wav")
    util.PrecacheModel("models/mc_block.mdl")
    util.PrecacheModel("models/mc_multiblock.mdl")
    util.PrecacheModel("models/mc_tntblock.mdl")
    util.PrecacheModel("models/mc_furnace.mdl")
    util.PrecacheModel("models/mc_pumpkin.mdl")
    util.PrecacheModel("models/minecraft/mc_rock.mdl")
    return true  
end

local function SaveMaterial( Player, Entity, Data )
    Entity:SetMaterial( Data.MaterialOverride )    
    if ( SERVER ) then
        duplicator.StoreEntityModifier( Entity, "material", Data, Value )
    end
    return true
end
duplicator.RegisterEntityModifier( "material", SaveMaterial )

local function SaveKeyvalue( Player, Entity, Data )
    Entity:SetKeyValue( Data.Key, Data.Value )
    if (SERVER) then
        duplicator.StoreEntityModifier( Entity, "keyvalue", Data, Value )
        end
    return true
    end
duplicator.RegisterEntityModifier( "keyvalue", SaveKeyvalue )

local function SaveName( Player, Entity, Data )
    Entity:SetKeyValue( Data.Key, Data.Value )
    if (SERVER) then
        duplicator.StoreEntityModifier( Entity, "targetname", Data, Value )
        end
    return true
end
duplicator.RegisterEntityModifier( "targetname", SaveName )

local function SaveHealth( Player, Entity, Data )
    Entity:SetHealth( Data.HealthOverride )
    if (SERVER) then
        duplicator.StoreEntityModifier( Entity, "health", Data, Value )
    end
    return true
end
duplicator.RegisterEntityModifier( "health", SaveHealth )

local function SaveInvincibility( Player, Entity, Data )
    Entity:SetKeyValue( Data.Key, Data.Value)
    if (SERVER) then
        duplicator.StoreEntityModifier( Entity, "damagefilter", Data, Value )
    end
    return true
end
duplicator.RegisterEntityModifier( "damagefilter", SaveInvincibility )

//Player = :GetAimVector()
local blockcount = 0
local lastmat = 0
local vmcheck = 1
local IsWeapon = 1
local Mat = 0
local zpos = 0
local Blah = false
local Bleh = false
local ShootSound = Sound( "Concrete.ImpactHard" )
local BreakSound = Sound( "Breakable.Concrete" )
local Block = {
    "models/minecraft/adminium",    //1
    "models/minecraft/bloodstone",  //2
    "models/minecraft/bricks",      //3
    "models/minecraft/clay",        //4
    "models/minecraft/coal_ore",    //5
    "models/minecraft/cobblestone", //6
    "models/minecraft/creeper_mud", //7
    "models/minecraft/diamond_ore", //8
    "models/minecraft/dirt",        //9
    "models/minecraft/glass",       //10
    "models/minecraft/gold_ore",    //11
    "models/minecraft/gravel",      //12
    "models/minecraft/iron_ore",    //13
    "models/minecraft/lightstone",  //14
    "models/minecraft/mossy_cobblestone",//15
    "models/minecraft/obsidian",    //16
    "models/minecraft/redstone_ore",//17
    "models/minecraft/sand",        //18
    "models/minecraft/snow",        //19
    "models/minecraft/sponge",      //20
    "models/minecraft/stone",       //21
    "models/minecraft/wood_plank",  //22
    "models/minecraft/glass", //23
    "models/minecraft/ice",   //24
    "models/minecraft/bush",  //25
    "models/minecraft/iron",  //26
    "models/minecraft/gold",  //27
    "models/minecraft/diamond",//28
    "models/minecraft/wood",  //29
    "models/minecraft/tnt",   //30
    "models/minecraft/dirt_block",//31
    "models/minecraft/workbench", //32
    "models/minecraft/dirt_snow", //33
    "models/minecraft/pumpkin",   //34
    "models/minecraft/furnace",   //35
    "models/minecraft/chest",     //36
    "models/minecraft/bookshelf", //37
    "models/minecraft/mobspawner",//38
    "models/minecraft/jukebox",   //39
    "models/minecraft/water",     //40
    "models/minecraft/lava" }     //41

local BlockModel = {
    "models/minecraft/mc_rock.mdl", //1
    "models/minecraft/mc_zombieflesh.mdl", //2
    "models/minecraft/mc_rock.mdl", //3
    "models/minecraft/mc_sand.mdl", //4
    "models/minecraft/mc_rock.mdl", //5
    "models/minecraft/mc_rock.mdl", //6
    "models/minecraft/mc_mud.mdl", //7
    "models/minecraft/mc_rock.mdl", //8
    "models/minecraft/mc_dirt.mdl", //9
    "models/minecraft/mc_glass.mdl", //10
    "models/minecraft/mc_rock.mdl", //11
    "models/minecraft/mc_gravel.mdl", //12
    "models/minecraft/mc_rock.mdl", //13
    "models/minecraft/mc_glass.mdl", //14
    "models/minecraft/mc_rock.mdl", //15
    "models/minecraft/mc_rock.mdl", //16
    "models/minecraft/mc_rock.mdl", //17
    "models/minecraft/mc_sand.mdl", //18
    "models/minecraft/mc_snow.mdl", //19
    "models/minecraft/mc_foliage.mdl", //20
    "models/minecraft/mc_rock.mdl", //21
    "models/minecraft/mc_wood_plank.mdl", //22
    "models/minecraft/mc_glass.mdl", //23
    "models/minecraft/mc_glass.mdl", //24
    "models/minecraft/mc_grass.mdl", //25
    "models/minecraft/mc_metal_box.mdl", //26
    "models/minecraft/mc_metal_box.mdl", //27
    "models/minecraft/mc_metal_box.mdl", //28
    "models/minecraft/mc_wood_multiblock.mdl", //29
    "models/mc_tntblock.mdl", //30
    "models/minecraft/mc_grass_multiblock.mdl", //31
    "models/minecraft/mc_wood_multiblock.mdl", //32
    "models/minecraft/mc_snow_multiblock.mdl", //33
    "models/mc_pumpkin.mdl", //34 --------!!!
    "models/mc_furnace.mdl", //35 --------!!!
    "models/minecraft/mc_chest_multiblock.mdl", //36
    "models/minecraft/mc_wood_multiblock.mdl",  //37
    "models/minecraft/mc_metal_box.mdl",        //38
    "models/minecraft/mc_wood_multiblock.mdl",  //39
    "models/minecraft/mc_glass.mdl",            //40
    "models/minecraft/mc_gravel.mdl" }          //41
    
function SWEP:GetViewModelPosition( pos, ang )
    
    local Pos = Vector (-10,75,-50)
    ang:RotateAroundAxis( ang:Up(), -30 )
    ang:RotateAroundAxis( ang:Right(), 10 )
    

    local Right     = ang:Right()
        local Up         = ang:Up()
        local Forward     = ang:Forward()
    
        pos = pos + Pos.x * Right
        pos = pos + Pos.y * Forward
        pos = pos + Pos.z * Up


    return pos, ang
 
end

/*---------------------------------------------------------
Reload pops up the menu
---------------------------------------------------------*/
function SWEP:Reload()
    Bleh = true
    if (Blah == false) then
        Blah = true
        if (firstspawn == 0) then
	if (SERVER) then
            RunConsoleCommand("mc_menu"); //normal
        end
	end
        if (firstspawn == 1) then
	if (SERVER) then
            RunConsoleCommand("mc_firstinfo") //first time
            firstspawn = 0
        end
	end
    end
end

/*---------------------------------------------------------
Think  & Material Think
---------------------------------------------------------*/
function SWEP:Think()  
    self:VMThink()
    self:MatThink()
    if (vmcheck == 1) then //only exec the viewmodel:SetModel function when m_iMat changes (and not every think) to save performance
        self:ViewmodelThink()
        vmcheck = 0
    end
    if (Bleh == false) then
        Blah = false
    end
    Bleh = false
   // local VM = self:GetOwner():GetViewModel()
   // VM:SetMaterial( "models/shadertest/shader2" )

end

function SWEP:MatThink()
    if(!ValidEntity(self:GetOwner())) then return; end
    local VM = self:GetOwner():GetViewModel();
    //if not VM:IsValid() then return end

    if(!ValidEntity(VM)) then return; end // Just wait a while - it'll come back, eventually.
    self:SetNetworkedVar("m_iMat", GetConVar("minecraft_blocktype"):GetInt());
    VM:SetMaterial( Block[self:GetMat()] )
    
end

function SWEP:ViewmodelThink()
    if (!ValidEntity(self:GetOwner())) then return; end
    local VM = self:GetOwner():GetViewModel();
    if (!ValidEntity(VM)) then return; end
    if ((self:GetMat()) < 26) then
        VM:SetModel( "models/mc_block.mdl" )
    end
    if ((self:GetMat()) > 25) then
        VM:SetModel( "models/mc_multiblock.mdl" )
        end
    if ((self:GetMat()) == 40 || (self:GetMat()) == 41) then
	VM:SetModel( "models/mc_block.mdl" )
    end
    //print("ViewmodelThink() called")
end

function SWEP:VMThink()
    if (lastmat != (self:GetMat())) then
        vmcheck = 1
    end
    lastmat = self:GetMat()
end
    

AccessorFuncNW(SWEP,"m_iMat","CurrentMat",0,FORCE_NUMBER);

function SWEP:GetMat()
    return self:GetNetworkedInt("m_iMat");
end
function SWEP:SetMat( matnumber )
    self:SetNetworkedVar("m_iMat", matnumber)
end

/*---------------------------------------------------------
    Main Attack Function
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
    if (GetConVar("minecraft_swapattack"):GetInt() > 0) then
        self:MCPrimaryAttack()
    end
    if (GetConVar("minecraft_swapattack"):GetInt() < 1) then
        self:MCSecondaryAttack()
    end
end
function SWEP:PrimaryAttack()
    if (GetConVar("minecraft_swapattack"):GetInt() > 0) then
        self:MCSecondaryAttack()
    end
    if (GetConVar("minecraft_swapattack"):GetInt() < 1) then
        self:MCPrimaryAttack()
    end
end

function SWEP:MCSecondaryAttack()
 
    local tr = self.Owner:GetEyeTrace()
    local startpos = self.Owner:GetShootPos()
    local isBlock = false
    
    local tracedata = {}
    tracedata.start = startpos
    tracedata.endpos = tr.HitPos + tr.HitNormal * 16
    tracedata.filter = self.Owner
    
    local checktr = util.TraceLine(tracedata)
    if checktr.HitNonWorld then
        target = checktr.Entity
        if ( target ) then isBlock = true
        end
    end
    local checkent = 0
    local checkvec = Vector(0,0,0)
    if tr.HitNonWorld then
        checkent = tr.Entity
        checkvec = checkent:GetPos()
        if (debuginfo == 1) then print("checktr hit nonworld!") end
    end

    local SpawnPos = tr.HitPos + tr.HitNormal * 16
    
    local distvec = tr.HitPos - self.Owner:GetPos()
    local length = distvec:Length()
    
    if (GetConVar("minecraft_distancelimit"):GetInt() > 0) then
        if (length > GetConVar("minecraft_maxspawndist"):GetInt()) then
            isBlock = true
        end
    end

    if ( isBlock == false ) then
        if (GetConVar("minecraft_disablesounds"):GetInt() < 1) then
		local rnd = math.random(3)
		if (rnd == 1) then
            		self:EmitSound( "minecraft/concrete_impact_hard1.wav" )
		end
		if (rnd == 2) then
			self:EmitSound( "minecraft/concrete_impact_hard2.wav" )
		end
		if (rnd == 3) then
			self:EmitSound( "minecraft/concrete_impact_hard3.wav" )
		end
        end
    end
    
    // The rest is only done on the server
    if (!SERVER) then return end
    
    if ( isBlock == false && tr.HitWorld == false && GetConVar("minecraft_spawntype"):GetInt() == 2) then
        
        //check wether we are placing on top, bottom, or the four sides
        local hitz = tr.HitPos.z
        local checkvecz = checkvec.z
        local hmc = hitz - checkvecz   //hmc should be about '16' when placing on top OR on bottom
 
        if (hitz < 0) then
            hitz = - hitz
        end
        if (checkvecz <0) then
            checkvecz = - checkvecz
        end
        local hmc2 = hitz - checkvecz
        if (hmc2 < 0) then
            hmc2 = - hmc2
        end
        
        local toporbottom = 0
        if (hmc2 > 15.9 && hmc2 < 16.1) then // top OR bottom
            if (hmc < 0) then
                toporbottom = 2
                if (debuginfo == 1) then print("bottom = " .. tostring(toporbottom)) end
            end
            if (hmc > 0) then
                toporbottom = 1
                if (debuginfo == 1) then print("top = " .. tostring(toporbottom)) end
            end
        end
        
        if (toporbottom == 0) then  //one of the four sides
            if (tr.HitPos.z > checkvec.z) then
                zpos = math.floor( SpawnPos.z / 32 ) * 32 + 0
                if (debuginfo == 1) then print("upper half") end
            end
            if (tr.HitPos.z < checkvec.z) then
                zpos = math.floor( SpawnPos.z / 32 ) * 32 + 32
                if (debuginfo == 1) then print("lower half") end
            end
        end
        
        if (toporbottom == 1) then //top
            zpos = math.floor( SpawnPos.z / 32 ) * 32 + 32
            if ((SpawnPos.z - zpos) < -1) then // bug!
                zpos = math.floor( SpawnPos.z / 32) * 32 + 0
            end
            if (debuginfo == 2) then print("top->SpawnPos.z = " .. tostring(SpawnPos.z)) end
            if (debuginfo == 2) then print("top->zpos = " .. tostring(zpos)) end
        end
        
        if (toporbottom == 2) then //bottom
            zpos = math.floor( SpawnPos.z / 32 ) * 32 + 0
            if ((SpawnPos.z - zpos) > 1) then // bug!
                zpos =math.floor( SpawnPos.z / 32 ) * 32 + 32
            end
            if (debuginfo == 2) then print("bottom->SpawnPos.z = " .. tostring(SpawnPos.z)) end
            if (debuginfo == 2) then print("bottom->zpos = " .. tostring(zpos)) end
        end
        
        if (debuginfo == 1) then print("isBlock == false!!, checkvec.z = " .. tostring(checkvec.z)) end
        if (debuginfo == 1) then print("HitPos.z = " .. tostring(tr.HitPos.z)) end
    end
    
    if ( isBlock == true) then //block is blocking the way
        if (debuginfo == 1) then print("isBlock is true!") end
    end
    if ( tr.HitWorld == true && isBlock == false && GetConVar("minecraft_spawntype"):GetInt() == 2) then  //no block nearby
        zpos = math.floor( SpawnPos.z / 32 ) * 32 + 0
        if (debuginfo == 1) then print("tr.HitWorld !!!! && isBlock == false!") end
    end  
    
    if ( isBlock == false ) then  //pos is ok, block can be created
        
        if (GetConVar("minecraft_blocktype"):GetInt() > 41) then
            RunConsoleCommand("minecraft_blocktype", "41")
            self:SetMat( 41 )
            print("no!")
        end
        if (GetConVar("minecraft_blocktype"):GetInt() < 1) then
            RunConsoleCommand("minecraft_blocktype", "1")
            self:SetMat( 1 )
            print(">:(")
        end
            local ent = 0
            if (self:GetMat() != 40 && self:GetMat() != 41) then
                ent = ents.Create( "prop_physics" )
                lavaorwater = 0
            else
                ent = ents.Create( "prop_waterized" )
                local damping, density, buoyancy
                if (self:GetMat() == 40) then //water
                    damping = 15
                    density = 70
                    buoyancy = 600
                    lavaorwater = 0
                end
                if (self:GetMat() == 41) then //lava
                    damping = 40
                    density = 90
                    buoyancy = 300
                    lavaorwater = 1
                end
                MakeWaterizedProp( ent, self:GetOwner(), damping, density, buoyancy )
            end
			
            //local SpawnPos = tr.HitPos + tr.HitNormal * 16
            local xpos = math.floor( SpawnPos.x / 32 ) * 32 + 16
            local ypos = math.floor( SpawnPos.y / 32 ) * 32 + 16
        if (GetConVar("minecraft_spawntype"):GetInt() == 1) then
            zpos = math.floor( SpawnPos.z / 32 ) * 32 + 16
        end
        if (GetConVar("minecraft_spawntype"):GetInt() == 0) then
            zpos = SpawnPos.z
        end
            ent:SetModel( BlockModel[self:GetMat()])
            //ent:SetMaterial( Block[self:GetMat()])
            ent:SetPos( Vector( xpos, ypos, zpos) )
            ent:PhysicsInitBox( SpawnPos + Vector( -16, -16, -16 ), SpawnPos + Vector(  16,  16,  16 ) )
            ent:SetKeyValue( "DisableShadows", "1" )
            ent:SetKeyValue( "targetname", "mcblock" )
            ent:SetKeyValue( "spawnflags", 8 ) //disable movement!
        
        //these five functions are only used for toybox saving! (to make it work correctly)
        SaveMaterial(self:GetOwner(), ent, { MaterialOverride = Block[self:GetMat()] } )
        SaveKeyvalue(self:GetOwner(), ent, { Key = "DisableShadows" , Value = "1" } )
        SaveName(self:GetOwner(), ent, { Key = "targetname", Value = "mcblock" } )
        if ((self:GetMat()) != 30) then
            SaveHealth(self:GetOwner(), ent, { HealthOverride = GetConVar("minecraft_blockhealth"):GetInt() } )
            if (GetConVar("minecraft_blockhealth"):GetInt() > 0) then
                //SaveInvincibility(self:GetOwner(), ent, { Key = "damagefilter", Value = "FiltreDegats" } )
            end
        end
        if (GetConVar("minecraft_blockhealth"):GetInt() < 0) then
            local filter = "FiltreDegats"
            ent:Fire("setdamagefilter", filter, 0) //unbreakable
        end

            //print("spawnflags set")
            //ent:SetHealth( 100 )
            //ent:SetKeyValue( "sethealth", GetConVar("minecraft_blockhealth"):GetInt() )  
            ent:Spawn()
        if ((self:GetMat()) != 30 && GetConVar("minecraft_blockhealth"):GetInt() > 0) then   //tnt has its own health
            ent:SetHealth( GetConVar("minecraft_blockhealth"):GetInt() )
        end

        undo.Create("MC Block")
            undo.AddEntity( nocl )
            undo.AddEntity( ent )
            undo.SetPlayer( self.Owner )
            undo.Finish()
    end
end
/*---------------------------------------------------------
    MCSecondaryAttack
---------------------------------------------------------*/
function SWEP:MCPrimaryAttack()
    local spawndistance = GetConVar("minecraft_maxspawndist"):GetInt()
    local tr = self.Owner:GetEyeTrace()
        local distvec = tr.HitPos - self.Owner:GetPos()
        local length = distvec:Length()
    local ismcblock = 0
if (SERVER) then
    if (tr.Entity:IsValid()) then
    if (tr.Entity:GetName() == "mcblock") then
        ismcblock = 1
    else
        ismcblock = 0
    end
    end
end
if (GetConVar("minecraft_deletemconly"):GetInt() > 0 && ismcblock == 0) then return end

if (GetConVar("minecraft_distancelimit"):GetInt() < 1) then
    if tr.HitNonWorld then
        target = tr.Entity  
        if (target) then
                if (GetConVar("minecraft_disablesounds"):GetInt() < 1) then
			local rnd = math.random(2)
			if (rnd == 1 ) then
                    		self:EmitSound( "minecraft/concrete_break3.wav" )
			else
				self:EmitSound( "minecraft/concrete_break2.wav" )
			end
                end
            self:ShootEffects( self )
    
    local effectdata = EffectData()
        effectdata:SetOrigin( tr.HitPos )
        effectdata:SetNormal( tr.HitNormal )
        effectdata:SetMagnitude( 8 )
        effectdata:SetScale( 1 )
        effectdata:SetRadius( 16 )
        util.Effect( "GlassImpact", effectdata )
        end
    end
    // The rest is only done on the server
    if (!SERVER) then return end
    
    local trace = self.Owner:GetEyeTrace();
    if( not trace.HitWorld ) then // if you hit an entity
        if (ValidEntity(trace.Entity)) then
           trace.Entity:Remove()
        end
    end
end
if (GetConVar("minecraft_distancelimit"):GetInt() > 0) then
if (length < spawndistance) then
    if tr.HitNonWorld then
         target = tr.Entity  
         if (target) then
                if (GetConVar("minecraft_disablesounds"):GetInt() < 1) then
			local rnd = math.random(2)
			if (rnd == 1 ) then
                    		self:EmitSound( "minecraft/concrete_break3.wav" )
			else
				self:EmitSound( "minecraft/concrete_break2.wav" )
			end
                end
             self:ShootEffects( self )
     
     local effectdata = EffectData()
         effectdata:SetOrigin( tr.HitPos )
         effectdata:SetNormal( tr.HitNormal )
         effectdata:SetMagnitude( 8 )
         effectdata:SetScale( 1 )
         effectdata:SetRadius( 16 )
         util.Effect( "GlassImpact", effectdata )
        end
    end      
     // The rest is only done on the server
     if (!SERVER) then return end
     
     local trace = self.Owner:GetEyeTrace();
     if( not trace.HitWorld ) then // if you hit an entity
         if (ValidEntity(trace.Entity)) then
            trace.Entity:Remove()
         end
     end    
end
end

end
    
   
/*---------------------------------------------------------
   Name: ShouldDropOnDie
   Desc: Should this weapon be dropped when its owner dies?
---------------------------------------------------------*/
function SWEP:OnRemove()
    if(ValidEntity(self:GetOwner())) then
        local VM = self:GetOwner():GetViewModel();
    //if not VM:IsValid() then return end
        if(ValidEntity(VM)) then
            VM:SetMaterial("");
        end
    end
    IsWeapon = 0
end
function SWEP:ShouldDropOnDie()
    return false
end

function SWEP:Holster()
    if(ValidEntity(self:GetOwner())) then
        local VM = self:GetOwner():GetViewModel();
        if(ValidEntity(VM)) then
            VM:SetMaterial("");
        end
    end
    IsWeapon = 0
    return true
end

function SWEP:Deploy()
    //self:SendWeaponAnim(ACT_VM_DRAW)
    if (debuginfo == 1 ) then print("block deploy()!!!!") end
    IsWeapon = 1
    self:ViewmodelThink()
    return true
end


function removeall()
	for k, v in pairs( ents.GetAll() ) do
		if ( v:IsValid() ) then
		if (SERVER) then
			if ( v:GetName() == "mcblock" ) then
				v:Remove()
			end
		end
		end
	end
end

function MakeWaterizedProp( ent, ply, damping, density, buoyancy )
    -- Generic stufff
    if not ent:IsValid() then return end
    --duplicator.DoGeneric( ent, Data )
    ent:SetPlayer( ply )
    ent:Spawn()
    --duplicator.DoGenericPhysics( ent, ply, Data )

    -- Custom data
    ent:SetDamping( damping )
    ent.damping = damping
    ent:SetDensity( density )
    ent.density = density
    ent:SetBuoyancy( buoyancy )
    ent.buoyancy = buoyancy
	
    return ent
end

duplicator.RegisterEntityClass( "prop_waterized", MakeWaterizedProp, "damping", "density", "buoyancy", "Data" )

concommand.Add("minecraft_removeallblocks", removeall)